import re

from odoo import models

from odoo.addons.whatsapp.models.whatsapp_message import WhatsAppMessage

# Monkey patch to customize the delay before
# the answer are forwarded to the wa accounts Notified Users
WhatsAppMessage._ACTIVE_THRESHOLD_DAYS = 30

class WhatappTemplateVariable(models.Model):
    _inherit = 'whatsapp.template.variable'

    def _get_variables_value(self, record):
        def remove_ngram(variables):
            return {k: re.sub(r"(\s\(\w{2,4}\))$", '', ngram) for k, ngram in variables.items()}

        def is_username(v):
            return (v.field_name and v.field_name.endswith(("user_id", "user_id.name"))) or v.field_type == 'user_name'

        to_clean = self.filtered(is_username)
        to_keep = self.filtered(lambda v: not is_username(v))

        return {
            **super(WhatappTemplateVariable, to_keep)._get_variables_value(record),
            **remove_ngram(super(WhatappTemplateVariable, to_clean)._get_variables_value(record)),
        }
